package nocturne.jfly;

import java.io.PrintStream;
import java.text.MessageFormat;

/**
 *     
 */
public class TextFlyLog implements nocturne.jfly.IFlyLog
{
    //  
    private LogParameters _parameters;

    //   
    private PrintStream _stream;

    //  
    private int _currentIndent;

    public TextFlyLog(IFlyLog.LogParameters _parameters, PrintStream _stream)
    {
        this._parameters = _parameters;
        this._stream = _stream;
    }

    public TextFlyLog(PrintStream _stream)
    {
        this._stream = _stream;
        this._parameters = new LogParameters();
    }

    public TextFlyLog()
    {
        this._stream = System.out;
        this._parameters = new LogParameters();
    }

    /**
     *   
     * @param parameters -  
     */
    public void set_parameters(IFlyLog.LogParameters parameters)
    {
        _parameters = parameters;
    }

    /**
     *   
     * @return   
     */
    public IFlyLog.LogParameters get_parameters()
    {
        return _parameters;
    }

    /**
     *    
     *
     * @param automata -    
     * @param text -   
     */
    public void log(String automata, String text)
    {
        log(automata, text, NOTIFICATION);
    }

    /**
     *    
     *
     * @param automata -    
     * @param text -   
     * @param type -  
     */
    public void log(String automata, String text, int type)
    {
        String typeSymbol = "";

        if (_parameters.is_writeTimestamp())
        {
            _stream.print(MessageFormat.format("{0} ", new Object[] {new java.util.Date().toString()}));
        }

        switch (type)
        {
        case NOTIFICATION:
                typeSymbol = "*";

                writeIndent();
                _stream.print(typeSymbol);

                break;
        case ERROR:
                typeSymbol = "!";

                writeIndent();
                _stream.print(typeSymbol);


                break;
        case OPEN_SCOPE:
                typeSymbol = "{";

                writeIndent();
                _stream.print(typeSymbol);

                if (_parameters.is_scopeAutoIndent())
                    indent();

                break;
        case CLOSE_SCOPE:
                typeSymbol = "}";

                if (_parameters.is_scopeAutoIndent())
                    unindent();

                writeIndent();
                _stream.print(typeSymbol);

                break;
        }

        _stream.println(MessageFormat.format(" {0}", new Object[] {text}));
    }

    /**
     *  
     */
    public void indent()
    {
        _currentIndent += _parameters.get_indent();
    }

    /**
     *  
     */
    public void unindent()
    {
        _currentIndent -= _parameters.get_indent();
    }

    private void writeIndent()
    {
        for (int i = 0; i < _currentIndent; i++)
            _stream.print(" ");
    }
}
